package assignment05;

import org.gecode.*;
import static org.gecode.Gecode.*;
import static org.gecode.GecodeEnumConstants.*;

class LinearSum<IV extends IntView> extends NaryPropagator<IV> {
  private int c;

  public LinearSum(Space s, ViewArray<IV> iv0, int c0) {
      super(s, iv0, /* TODO: insert propagation condition here */);
      c = c0;
  }
  public LinearSum(Space s, Boolean share,
                   LinearSum<IV> p) {
      super(s, share, p);
      c = p.c;
  }
  public PropCost cost() {
      return cost_hi(iv.size(), PC_LINEAR_HI);
  }
  public ExecStatus propagate(Space home) {
      /* TODO: insert propagation here */
  }

  /** Post propagator for sum_i x_i = c */
  static void post(Space home, VarArray<IntVar> x, int c) {
    ViewArray<IntVarView> xa = new ViewArray<IntVarView>(home, IntVarView.class, x);

    Gecode.addPropagator(home,
                         new LinearSum<IntVarView>(home, xa, c));
  }
    
  /** Post propagator for sum_i coeff_i*x_i = c */
  static void post(Space home, int[] coeff, VarArray<IntVar> x, int c) {
    ViewArray<ScaleView<IntVarView>> xa =
      new ViewArray<ScaleView<IntVarView>>(x.size());
    for (int i=0; i<x.size(); i++)
      xa.add(new ScaleView<IntVarView>
             (home, coeff[i], new IntVarView(home, x.get(i))));
        
    Gecode.addPropagator(home,
                         new LinearSum<ScaleView<IntVarView>>(home,
                                                              xa, c));

  }
}
