package assignment05;

import org.gecode.*;
import static org.gecode.Gecode.*;
import static org.gecode.GecodeEnumConstants.*;

public class ScaleView<IV extends IntView> implements IntView {
    private IV v;
    private int c;

    /** Empty initializer.
     */
    public ScaleView() {}
    /** Initialize with coefficient c0 for view x.
     */
    public ScaleView(JavaSpace s, int c0, IV x) {
        v = x;
        c = c0;
    }

    @SuppressWarnings("unchecked") 
    public ScaleView<IV> copy(JavaSpace newHome, boolean share) {
        ScaleView<IV> nv = new ScaleView<IV>();
        nv.v = (IV)v.copy(newHome, share);
        nv.c = c;
        return nv;
    }
    public void subscribe(JavaSpace s, JavaPropagator p, PropCond pc) {
        v.subscribe(s, p, pc);
    }
    public void cancel(JavaSpace s, JavaPropagator p, PropCond pc) {
        v.cancel(s, p, pc);
    }

    public boolean assigned() { return v.assigned(); }
    public int val() { return v.val()*c; }
    public int min() { 
        if (c<0)
            return v.max()*c;
        else
            return v.min()*c;
    }
    
    public int max() {
        /* TODO: insert definition of max here */
    }

    public boolean in(int val) {
        throw (new UnsupportedOperationException("Not implemented"));
    }

    public IntModEvent lq(JavaSpace s, int i) {
        /* TODO: insert definition of lq here */
    }
    public IntModEvent eq(JavaSpace s, int i) {
        // Check if rounding occurs when dividing by c
        double xc = (double)i / (double)c;
        // if not, just delegate to v.eq
        if (Math.ceil(xc) == xc)
            return v.eq(s, (int)xc);
        // otherwise, we have failure
        return IntModEvent.ME_INT_FAILED;
    }
    public IntModEvent gq(JavaSpace s, int i) {
        /* TODO: insert definition of gq here */
    }
    public IntModEvent nq(JavaSpace s, int i) {
        /* TODO: insert definition of nq here */
    }

    public IntModEvent inter(JavaSpace s, RangeIterator iter) {
        throw (new UnsupportedOperationException("Not implemented"));
    }
}
